//gsoap ck service name: ng_se
//gsoap ck service location: http://www.nordugrid.org/ng_se
//gsoap ck service executable: ns.cgi
//gsoap ck service namespace: http://www.nordugrid.org/ng_se/ns.wsdl
//gsoap ck schema  namespace: urn:ns
//gsoap ck service action: urn:ns


enum ns__filestate {
  accepted = 0,
  collecting = 1,
  complete = 2,
  deleting = 3,
};

class ns__fileinfo {
 public:
  char* id;
  unsigned long long int* size;
  char* checksum;
  char* acl;
  char* created;
  enum ns__filestate* state;
  int __size_url;
  char** url;
  ns__fileinfo();
  ~ns__fileinfo();
};

struct ns__addResponse {
  int error_code;
  int sub_error_code;
  ns__fileinfo file;
};

struct ns__updateResponse {
  int error_code;
  int sub_error_code;
  ns__fileinfo file;
};

struct ns__infoResponse {
  int error_code;
  int sub_error_code;
  int __size_file;
  ns__fileinfo* file;
};

struct ns__aclResponse {
  int error_code;
  int sub_error_code;
  char* acl;
};

struct ns__delResponse {
  int error_code;
  int sub_error_code;
};

// create new file
int ns__add(
  ns__fileinfo *file,
  struct ns__addResponse &r
);

// update information about file (used to provide checksum after upload)
int ns__update(
  ns__fileinfo *file,
  struct ns__updateResponse &r
);

// get file info
int ns__info(
  char *pattern,
  struct ns__infoResponse &r
);

// get/set ACL
int ns__acl(
  char *acl,
  struct ns__aclResponse &r
);

// remove file
int ns__del(
  struct ns__delResponse &r
);


