/* write essential inforamtion about job started/finished */
#ifndef __GM_JOB_LOG_H__
#define __GM_JOB_LOG_H__

#include <string>
#include <fstream>
#include "../misc/escaped.h"
#include "../jobs/job.h"
#include "../jobs/users.h"
#include "../run/run.h"

/*
  Put short information into log when every job starts/finishes.
  Store more detailed information for Reporter.
*/
class JobLog {
 private:
  string filename;
  list<string> urls;
//  string cluster_name;
  RunElement *proc;
  time_t last_run;
  bool open_stream(ofstream &o);
 public:
  JobLog(void);
  JobLog(const char* fname);
  ~JobLog(void);
  /* chose name of log file */
  void SetOutput(const char* fname);
  /* log job start information */
  bool start_info(JobDescription &job,const JobUser &user);
  /* log job finish iformation */
  bool finish_info(JobDescription &job,const JobUser &user);
  /* read information stored by start_info and finish_info */
  static bool read_info(fstream &i,bool &processed,bool &jobstart,struct tm &t,JobId &jobid,JobLocalDescription &job_desc,string &failure);
  bool is_reporting(void) { return (urls.size() > 0); };
  /* Run external utility to report gathered information to logger service */
  bool RunReporter(JobUsers& users);
  /* Set url of service and local name to use */
  // bool SetReporter(const char* destination,const char* name = NULL);
  bool SetReporter(const char* destination);
  /* Create data file for Reporter */
  bool make_file(JobDescription &job,JobUser &user);
};

#endif
